/*****************************
        COMP_UTI.C -- various utility
        routines used in the compiling
        spreadsheet program.
********************************/


#include <stdio.h>



/**
        allocate dynamic memory
**/
char *zalloc(amt)
unsigned int amt;
{
        char *calloc();

        char *temp;

        temp = calloc(amt, 1);
        if(temp == (char *) 0) error("Insufficient Dynamic space");
        return(temp);
}


#define EOS '\0'

extern double _10E1;
#define _FPONE 1.0

#define ASCII_TO_NUM '0'
#define BASE _10E1
#define INV_BASE (_FPONE / _10E1)

double getdoub()
{
        static double conv_table[] =
        { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0};

        char next_buf_char();
        double power_10();
        int inv_flag;

        char ch;
        static unsigned int exp;
        static double accum, multiplier, frac;

        accum = 0;

        ch = next_buf_char();
        if(isdigit(ch))
          do
                accum = accum * BASE + conv_table[ch - ASCII_TO_NUM];
          while(isdigit(ch = next_buf_char()));

        if(ch == '.')
        {
                frac = 0.0;
                multiplier = INV_BASE;

                while(isdigit(ch = next_buf_char())){
                   frac = frac + multiplier * conv_table[ch - ASCII_TO_NUM];
                       multiplier *= INV_BASE;
                }
                accum += frac;
         }

        if(toupper(ch) == 'E')
        {
                ch = next_buf_char();
                inv_flag = (ch == '-');

                if(isdigit(ch))unnext_buf_char();

                exp = 0;
                while(isdigit(ch = next_buf_char()))
                      exp = exp * 10 + (ch - ASCII_TO_NUM);

                accum *= (inv_flag ? _FPONE / power_10(exp) : power_10(exp));

        }
        if(ch != EOS)unnext_buf_char();
        return accum;
}


double power_10(e)
unsigned int e;
{
        double mult, res;
        unsigned int exp;

        exp = e;
        mult = BASE;
        res = 1.0;

        while(exp)
        {
                if(exp & 1) res *= mult;
                mult *= mult;
                exp >>= 1;
        }
        return res;
}

#include <dos.h>

#define ZF_MASK 64
#define CH_READY (1<<8)
#define GET_CH 0
#define KBD_INT 22
#define LO_MASK 255
#define HI_SHIFT 8

int inkey()
{
        struct REGVAL inreg, outreg;
        unsigned int flags, i, j;

        inreg.ax = CH_READY;
        flags = sysint(KBD_INT, &inreg, &outreg);
        if((flags & ZF_MASK) != 0) return 0;

        inreg.ax = GET_CH;
        sysint(KBD_INT, &inreg, &outreg);
        if((outreg.ax & LO_MASK) != 0) return(outreg.ax & LO_MASK);
        return -(outreg.ax >> HI_SHIFT);
}


#define SCR_LEN 25
#define SCR_WID 80
#define REG_ATTRIB 7
void clrscr()
{
        unsigned int i;

        for(i=0; i<SCR_LEN; i++)
        {
                scr_pos(i, 0);
                scr_wac(' ', REG_ATTRIB, SCR_WID);
        }
        scr_pos(0, 0);
}
